const std = @import("std");

const Color = @import("graphics.zig").Color;
const Game = @import("game.zig").Game;

var hikarix: Game = undefined;

export fn init() void {
    hikarix = Game.init();
    log("Hikarix initialized\n", .{});
}
export fn draw(dt: f32) void {
    hikarix.update(dt);
    hikarix.draw();
}

// External functions //

export fn getBuffer() [*]u8 {
    return @ptrCast(&hikarix.canvas.buffer);
}
export fn getBufferWidth() usize {
    return hikarix.canvas.width();
}
export fn getBufferHeight() usize {
    return hikarix.canvas.height();
}

var logBuffer: [1024]u8 = undefined;
// extern fn consoleLog(msg: [*]const u8, len: usize) void;
fn consoleLog(msg: [*]const u8, len: usize) void {
    _ = msg;
    _ = len;
}
pub fn log(comptime format: []const u8, args: anytype) void {
    const msg = std.fmt.bufPrint(&logBuffer, format, args) catch unreachable;
    consoleLog(msg.ptr, msg.len);
}

// Tests //

test "init" {
    init();
}
test "draw" {
    init();
    draw(0.0);
}
