const std = @import("std");
const math = @import("math.zig");

const Vec = math.Vec;
const Vec2 = Vec(2, f32);

pub const Player = struct {
    position: Vec2 = Vec2.init(0, 0),
    direction: Vec2 = Vec2.init(0, 0),

    pub fn init(position: Vec2, direction: Vec2) Player {
        return Player{ .position = position, .direction = direction };
    }
    pub fn update(self: *Player, dt: f32) void {
        self.direction = self.direction.rotate(0.0005 * dt);
    }
};

test "Player init" {
    const player = Player.init(Vec2.init(1, 1), Vec2.init(1, 1));
    try std.testing.expectEqual(player.position, Vec2.init(1, 1));
    try std.testing.expectEqual(player.direction, Vec2.init(1, 1));
}
